%bcond_without toolchain_clang

%if %{with toolchain_clang}
%global toolchain clang
%else
%global toolchain gcc
%endif

Name:           lfortran
Version:        0.17.0
Release:        %autorelease
Summary:        a modern open-source (BSD licensed) interactive Fortran compiler
License:        BSD-Protection
URL:            https://lfortran.org/
Source:         https://lfortran.github.io/tarballs/release/lfortran-%{version}.tar.gz
Patch0:         https://gist.githubusercontent.com/topazus/ad9358a9544af9b1aad99a84145ce5ac/raw/35859ca8f9f10950c26edf913016232c1190b8b8/lfortran-fix-header.patch
Patch1:         https://raw.githubusercontent.com/topazus/fedora-src/main/lfortran-fix-static-linking.patch

%if %{with toolchain_clang}
BuildRequires:	clang
%else
BuildRequires:	gcc-c++
%endif

BuildRequires:  cmake
BuildRequires:  ninja-build
BuildRequires:  zlib-devel
BuildRequires:  zlib-static
BuildRequires:  llvm-devel
BuildRequires:  xeus-devel
BuildRequires:  xtl-devel
BuildRequires:  json-devel
BuildRequires:  cppzmq-devel

%description
LFortran is a modern open-source (BSD licensed) interactive Fortran compiler
built on top of LLVM. It can execute user's code interactively to allow
exploratory work (much like Python, MATLAB or Julia) as well as compile to
binaries with the goal to run user's code on modern architectures such as
multi-core CPUs and GPUs.

%prep
%autosetup -p1

%build
%cmake \
  -G Ninja \
  -DCMAKE_BUILD_TYPE=Release \
  -DWITH_LLVM=yes
%cmake_build

%install
%cmake_install

%check
%ctest

%files
%license LICENSE
%doc README.md
%{_bindir}/lfortran
%dir %{_datadir}/lfortran
%{_datadir}/lfortran/lib/

%changelog
%autochangelog
